/*
sdlacfg.h

	Property page provider for sdladrv.sys on Windows 2000/XP/2003.


 		Ver 1,0,0,0	Feb 25, 2005		David Rokhvarg
 	Initial version.
 
*/


#ifndef _SDLACFG_H
#define _SDLACFG_H

#include "resource.h"

#include <windowsx.h>			//for GET_WM_COMMAND_CMD() macro
#include <stdio.h>				//for snprintf()
#include <stdlib.h>				//for atoi()

#include <wanpipe_defines.h>	//for 'wan_udp_hdr_t'
#include <sang_status_defines.h>//return codes
#include <sang_api.h>			//for IOCTL codes

#include <sdla_te1.h>			//for TE1 macros
#include <sdla_56k.h>			//for 56k macros
#include <sdla_remora.h>		//Analog card
#include <sdla_te3.h>			//T3 card
#include <sdla_bri.h>
#include <sdla_front_end.h>		//for front-end (T1/E1/56k) commands
#include <wanpipe_cfg.h>		//for WAN_MEDIA_NONE...

#include <sdla_remora.h>

#include <sdlasfm.h>
#include <sdlapci.h>

//define this to get output in WinDbg
//#define _MYDEBUG

#define PROGRAM_NAME "SdlaCfg: "
#include <DebugOut.h>	//debug macros

#define snprintf _snprintf
//to get debug output from a page define as 1
#define DRV_CFG_PAGE	0
#define DBG_SAM_CLASS	0
#define DBG_AFT_PAGE	0	
#define DBG_AFTUP		0
#define DBG_ANALOG_PAGE	0
#define DBG_AFT_SERIAL_PAGE	0
#define DBG_ADSL_PAGE	0
#define DBG_AFT_BRI_PAGE	0

//Help topics IDs
#define IDH_DRIVER_CFG		1
#define IDH_LINE_CFG		4

#ifndef __FUNCTION__
#define __FUNCTION__ "function"
#endif

////////////////////////////////////////////////////////////////////////////////

BOOL WINAPI MediaPageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK MediaPageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI DrvPageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK DrvPageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI AFT_PageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK AFT_PageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI AFTFirmwareUpdateDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK AFTFirmwareUpdatePageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI AFT_Analog_PageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK AFT_Analog_PageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI AFT_Serial_PageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK AFT_Serial_PageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI ADSL_PageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK ADSL_PageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

BOOL WINAPI AFT_BRI_PageDlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);
UINT CALLBACK AFT_BRI_PageCallbackProc(HWND junk, UINT msg, LPPROPSHEETPAGE p);

////////////////////////////////////////////////////////////////////////////////

DWORD GetRegistryDWordValue(HKEY hKey, LPTSTR szKeyname);
void SetRegistryDWordValue(HKEY hKey, LPTSTR szKeyname, DWORD dwValue);
void GetRegistryStringValue(HKEY hkey, LPTSTR szKeyname, LPSTR szValue, DWORD * pdwSize);
void SetRegistryStringValue(HKEY hkey, LPTSTR szKeyname, LPSTR szValue);
void SetRegistryStringValue(HKEY hkey, LPTSTR szKeyname, int iValue);

//returns the number in char array or -1 if not a number
int		is_number(char * buff);
BOOL	CheckActiveChannels(PUCHAR ActiveChannels, unsigned char media_type);
unsigned long parse_active_channel(char* val, unsigned char media_type, unsigned char is_unframed_e1);
int		yes_no_question(char* question);
void	restart_device();
int		start_monitor(int if_index);
void	set_dialog_wanpipe_name(HWND hdlg);
bool is_legacy_api_mode(char *operational_mode);

#define NO FALSE
#define YES TRUE

#define BIGBUFF 256

//return codes from OnNotfy()
#define HANDLE_DEFAULT	0
#define HANDLE_OK		1
#define HANDLE_ERROR	2


typedef struct _look_up
{
	const char	*name;
	u32			value;
}look_up_t;


//This is defined in wanpipe_tdm_api.h, but only for kernel,
//so have to redefine here.
#define WP_TDM_API_MAX_LEN 	1024

#define MIN_AFT_MTU		8	
#define MAX_AFT_MTU		8188

#define TMP_BUFFER_LEN	512

struct SETUPSTUFF {
	HDEVINFO info;
	PSP_DEVINFO_DATA did;
};

#define NOT_INIT_STR	"?"

typedef struct _AFT_LOGIC_CH_CFG{

	char active_ch_str[TMP_BUFFER_LEN];
	char line_mode[TMP_BUFFER_LEN];
	char mtu[TMP_BUFFER_LEN];
	char operational_mode[TMP_BUFFER_LEN];
	unsigned char decimal_idle_char;
	unsigned char analog_module_type;	//MOD_TYPE_FXO or MOD_TYPE_FXS

}AFT_LOGIC_CH_CFG;


typedef struct _GLOBALS
{
	int log_errors;

	char DeviceName[TMP_BUFFER_LEN];
#define MIN_WP_NUMBER	0	/* 0 means auto, else user provided */
#define MAX_WP_NUMBER	128
	unsigned short	wanpipe_number;

	//Serial media configuration stuff
	unsigned int electrical_interface;
	unsigned int clock_source;
	unsigned int BaudRate;

	//T1/E1/Analog/BRI media configuration stuff
	sdla_fe_cfg_t front_end_cfg;

	//AFT
	unsigned short aft_number_logic_channels;
	AFT_LOGIC_CH_CFG aft_logic_ch_cfg[NUM_OF_E1_TIMESLOTS];

	//ADSL
	wan_adsl_conf_t	adsl_cfg;

	u32 serial_connection_type, serial_line_coding, serial_line_idle;

	u32 start_port_when_computer_starts;

}GLOBALS;

extern GLOBALS Globals_Old_Cfg;
extern GLOBALS Globals_New_Cfg;

extern SETUPSTUFF * stuff;

extern HKEY	hkey;
extern BOOL	okay;

extern UCHAR released_by_OK_button;

extern HINSTANCE hInst;

extern int  iCardType;
extern int	 iCardSubType;
extern unsigned int iAutoWanpipeNumber;

#endif //_SDLACFG_H
