/*****************************************************************************
* wanpipe_ctypes.h WANPIPE(tm) - Basic Data types for Sangoma MS Windows API.
*
* Author: 	David Rokhvarg <davidr@sangoma.com
*
* Copyright:	(c) 2007 Sangoma Technologies Inc.
*
* ============================================================================
* Nov 27, 2007  David Rokhvarg	Initial version
* ============================================================================
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
*/

#ifndef _WANPIPE_CTYPES_H
#define _WANPIPE_CTYPES_H

/************* Basic data types **********/

/* signed types */
#define int8_t		INT8		
#define int16_t		INT16
#define int32_t		INT32		
#define int64_t		INT64

typedef int8_t		int8;
typedef int16_t		int16;
typedef int32_t		int32;
typedef int64_t		int64;

/* unsigned types */
#define u_int8_t	UINT8
#define u_int16_t	UINT16
#define u_int32_t	UINT32
#define u_int64_t	UINT64

#if defined(WAN_KERNEL)
typedef LONG			long_t;
typedef ULONG			ulong_t;
#else
typedef long			long_t;
typedef unsigned long	ulong_t;
#endif

typedef ulong_t			u_long;

typedef u_int8_t	uint8_t;
typedef u_int16_t	uint16_t;
typedef u_int32_t	uint32_t;
typedef u_int64_t	uint64_t;

typedef uint8_t		u8;
typedef uint16_t	u16;
typedef uint32_t	u32;
typedef uint64_t	u64;

typedef uint8_t		__u8;
typedef uint16_t	__u16;
typedef uint32_t	__u32;
typedef uint64_t	__u64;

#if defined(WAN_KERNEL)
typedef u_int8_t		u_char;
typedef unsigned int	UINT,	*PUINT;

/* AFT Dma addresses are MAXIMUM 32-bits wide!!! This is why this declaration is safe: */
typedef u32		dma_addr_t;
/*typedef PHYSICAL_ADDRESS	dma_addr_t;*/
/*typedef LONGLONG		dma_addr_t;*/
#endif

typedef char*		caddr_t;

/******** End of Basic data types ********/

typedef u32	gfp_t;

#endif
