/*****************************************************************************
* wanpipe_time.h WANPIPE(tm) - Portable Time routines for Sangoma MS Windows API.
*
* Author: 	David Rokhvarg <davidr@sangoma.com
*
* Copyright:	(c) 2007 Sangoma Technologies Inc.
*
* ============================================================================
* Nov 27, 2008  David Rokhvarg	Initial version
* ============================================================================
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
*/

#ifndef _WANPIPE_TIME_H
#define _WANPIPE_TIME_H

#if !defined(WAN_KERNEL)

#include <time.h>		/* time_t */
#include <Winsock2.h>	/* struct timeval */

static void gettimeofday(struct timeval *tv, void*not_used)
{	
	time( (time_t*)&tv->tv_sec ); /* Get time as long integer. */
}

static void localtime_r(long_t *long_time, struct tm *t)
{
	memcpy(t, localtime((time_t*)long_time), sizeof(struct tm)); /* Convert to local time. */
}
#endif/* WAN_KERNEL */


#endif/* _WANPIPE_TIME_H */
